/*!
 * \file    config.h
 * \brief   Build configuration file.
 *
 * \author
 *    Christos Choutouridis AEM:8997
 *    <cchoutou@ece.auth.gr>
 */

#ifndef CONFIG_H_
#define CONFIG_H_

#include <iostream>
#include <string>

/*
 * Defines for different version of the exercise
 */
#define  BITONIC        (1)
#define  BUBBLETONIC    (2)


// Fail-safe version selection
#if !defined CODE_VERSION
#define CODE_VERSION   BITONIC
#endif


/*!
 * Session option for each invocation of the executable
 */
struct session_t {
    bool timing{false};
    bool verbose{false};    //!< Flag to enable verbose output to stdout
};

extern session_t session;


#endif /* CONFIG_H_ */
